// This code is copyright (c) by Makoto Miyazaki
// Distributed under an MIT license
// 非常に煩雑なソースコードですがご容赦ください。

var applicationVersion = 1.1;

var importJs =  new Array(
	"modernizr.custom.js",
	"jquery.leanModal.min.js",
	"codemirror.js",
	"javascript.js",
	"jquery.confirm.js"
);
var textAreaTheme = "neat";
var importCss =  new Array(
	"button/normalize.css",
	"button/component.css",
	"button/override.css",
	"codemirror.css",
	"jquery.confirm.css",
	"theme/" + textAreaTheme + ".css",
	"selectStage.css"
);
for(var i = 0; i < importJs.length; i++) {
	document.write('<script type="text/javascript" src="./libs/' +importJs[i] +'"><\/script>'); 
}
document.write('<script type="text/javascript" src="http://www.ric.co.jp/version.js"><\/script>'); 

for(var i = 0; i < importCss.length; i++) {
	document.write('<link rel="stylesheet" type="text/css" href="./styles/' + importCss[i] + '" media="all" />'); 
}

<!-- プログラム領域のイベントバインド -->
function ModalData(title, editAreaList, buttonList) {
	this.title = title;
  this.editAreaList = editAreaList;
  this.buttonList = buttonList;
}

var dataMap = {
	"5" : new ModalData("もじ・かず・ふらぐ", ["codeMain"], ["addPrintln"]),
	"7" : new ModalData("いふん", ["codeCommon", "codeMain",  "codeUp", "codeRight", "codeDown", "codeLeft"], ["addPrintln", "addImg"]),
	"9" : new ModalData("ふぉお・ほわいる", ["codeMain"], ["addPrintln", "addImg"]),
	"10" : new ModalData("あるご・りずむ・クラッカー", ["codeCommon", "codeMain",  "codeUp", "codeRight", "codeDown", "codeLeft"], ["addPrintln", "addImg"]),
};

var currentEditorId = "codeMain";

var fncShowStudy = function(type) {
	$("#chapter" + type).click(function() {
			$("#codeArea").show();

			var modalData = dataMap[type];
			var title = modalData.title;

			$("#title").html(title);

			initTextArea();

			//テキストエリアの表示制御
			$(".code").parent().hide();
			$("#codeMain").parent().show();
			//切り替えボタンの表示
			if(modalData.editAreaList.length > 1) {
				currentEditorId = "codeMain";
				$("#buttonArea").append("<div class=\"switchArea\"><hr></div>");
				$("#buttonArea").append("<div class=\"buttonTitle switchArea\">画面切り替え</div>");

				for(var i = 0; i < modalData.editAreaList.length; i++) {
					var editArea = $("#" + modalData.editAreaList[i]);

					var button = $("<div>");
					button.addClass("switchArea").addClass("switchButton");
					button.data("editorId", editArea.attr("id"));
					if(editArea.attr("id") == currentEditorId) {
						button.addClass("disabled");
					} else {
						button.addClass("btn-small");
					}
					button.html(editArea.parent().children(".codeTitle").html());
					button.click(function() {
						var id = $(this).data("editorId");
						if(id == currentEditorId) {
							return;
						}
						$("#" + currentEditorId).parent().animate( { height: 'hide' }, 'slow');
						currentEditorId = id;
						$("#" + id).parent().animate( { height: 'show' }, 'slow');
						$(".switchButton").removeClass("disabled").addClass("btn-small");
						$(this).addClass("disabled").removeClass("btn-small");
					});
					$("#buttonArea").append(button);
				}
			}

			//ボタンの表示制御
			$(".commandButton").hide();
			for(var i = 0; i < modalData.buttonList.length; i++) {
				var button = $("#" + modalData.buttonList[i]);
				if(button) {
					button.show();
				}
			}

			$(this).leanModal({ top : 30, overlay : 0.5, closeButton: "#close", modalId : "studyArea", 
				onCloseCallback : function() {
					if($("#resultArea").css('display') == 'block') {
						closeResult();
						return false;
					}

					$("#studyArea").fadeOut("fast", function() {
										//CodeMirrorをクリア
										var mirror = $(".CodeMirror");
										mirror.remove();

										//studyAreaの状態も初期化
										$("#studyArea").attr("style", "");

										//入力欄の非表示化
										$("#codeArea").fadeOut();
										$(".switchArea").remove();
										$("#resultArea").hide();
										//入力欄（個別）の表示
										$(".code").parent().show();
								}
					);
					return true;
				}
			});
	});
}

$(document).ready(function(){
	fncShowStudy("5");
	fncShowStudy("7");
	fncShowStudy("9");
	fncShowStudy("10");

	//ボタンのイベントバインド
	$("#exec").click(function () {
		execute();
	});

	$("#addPrintln").click(function() {
		addPrintln();
	});

	$("#addImg").click(function() {
		addImg();
	});

	$("#resultArea>#header>#close").click(function() {
		closeResult();
	});

	loadVersion();
});

var jsEditor;

function initTextArea() {
	jsEditor = new Array();
	var editor = $(".code");
	for(var i = 0; i < editor.length; i++) {
		var e = editor[i];
	//FIXME cookieから保存されたコードを取得する
		editor.html("");
		var ce = CodeMirror.fromTextArea(e, {
			mode: "javascript",
			theme :textAreaTheme,
			lineNumbers: true,
			indentUnit: 2,
			id : $(e).attr("id")
		});
		jsEditor.push(ce);
	}
	saveEditor();
}

/***********************************************
 *
 * ボタン押下処理
 *
 ***********************************************/
function addPrintln() {
	addLine("println();");
	addLine("\n");
}

function addImg() {
	addLine("img(\"\", 0, 0);");
	addLine("\n");
}

function addLine(str) {
	var lastFocusEditor;
	for(var i = 0; i < jsEditor.length; i++) {
		var ce = jsEditor[i];
		if(ce.options.id == currentEditorId) {
			lastFocusEditor = ce;
			break;
		}
	}

	if(lastFocusEditor) {
		lastFocusEditor.replaceRange(str, CodeMirror.Pos(lastFocusEditor.lastLine()));
	} else {
		
	}
}

function saveEditor() {
	for(var i = 0; i < jsEditor.length; i++) {
		jsEditor[i].save();
	}
}
/***********************************************
 *
 * 実行処理
 *
 ***********************************************/
var loopId = 0;
var intervalArray = new Array();

function execute() {
	loopId = 0;
	intervalArray = new Array();
	saveEditor();

	var js = makeJs();
	try {
		$("#resultBody").html("");
		executeResult();
	} catch(e) {
		console.log(e);
		$("#resultBody").html("");
		$("#resultBody").append("<div class='errorMessage'>エラーが起きたようじゃな。プログラムの内容を見直すんじゃ。</div>");
	}

	$("#resultArea").animate({top : 'toggle'}, 300);
}

function closeResult() {
		$("#resultArea").animate({top : 'toggle'}, 300);
		$("#resultBody").html("");
		$(document).unbind("keydown");
		for(var i = 0; i < intervalArray.length; i++) {
			clearInterval(intervalArray[i]);
		}
}

var returnCode = "\n";

function makeJs() {
	var errorJs = "";
	var js = "<script type=\"text/javascript\">";
	var hasOtherArea = false;
	//共通エリアの読み込み
	if($("#codeCommon")) {
		hasOtherArea = true;
		var commonCode = $("#codeCommon").val();
		var validCommon = validate(commonCode, "共通");
		if(validCommon.length > 0) {
			errorJs += validCommon;
		} else {
			js += makeAllLines(commonCode);
		}
	}

	//キーバインドの読み込み
	var addExeCode = "";
	if($("#codeLeft")) {
		hasOtherArea = true;
		var codeLeft = $("#codeLeft").val();
		var validLeft = validate(codeLeft, "←キー");
		if(validLeft.length > 0) {
			errorJs = validLeft;
		} else {
			var functionName = "bindKeyLeft";
			js += makeBindKeyDownJs(functionName, 37, "clearImage();" + makeAllLines(codeLeft));
			addExeCode += functionName + "();";
		}
	}
	if($("#codeUp")) {
		hasOtherArea = true;
		var upCode = $("#codeUp").val();
		var validUp = validate(upCode, "↑キー");
		if(validUp.length > 0) {
			errorJs = validUp;
		} else {
			var functionName = "bindKeyUp";
			js += makeBindKeyDownJs(functionName, 38, "clearImage();" + makeAllLines(upCode));
			addExeCode += functionName + "();";
		}
	}
	if($("#codeRight")) {
		hasOtherArea = true;
		var codeRight = $("#codeRight").val();
		var validRight = validate(codeRight, "→キー");
		if(validRight.length > 0) {
			errorJs = validRight;
		} else {
			var functionName = "bindKeyRight";
			js += makeBindKeyDownJs(functionName, 39, "clearImage();" + makeAllLines(codeRight));
			addExeCode += functionName + "();";
		}
	}
	if($("#codeDown")) {
		hasOtherArea = true;
		var codeDown = $("#codeDown").val();
		var validDown = validate(codeDown, "↓キー");
		if(validDown.length > 0) {
			errorJs = validDown;
		} else {
			var functionName = "bindKeyDown";
			js += makeBindKeyDownJs(functionName, 40, "clearImage();" + makeAllLines(codeDown));
			addExeCode += functionName + "();";
		}
	}

	//メインエリアの読み込み
	var mainCode = $("#codeMain").val();
	var area = "";
	if(hasOtherArea) {
		area = "メイン";
	}
	var validMain = validate(mainCode, area);
	if(validMain.length > 0) {
		errorJs += validMain;
	} else {
		js += "function executeResult() { ";
		js += makeAllLines(mainCode);
		js += addExeCode;
		js += "}";
	}

	js += "</script>";

	var customizeScriptArea = $("#customizeScriptArea");
	if(errorJs.length > 0) {
		customizeScriptArea.html("<script type=\"text/javascript\">function executeResult() { " + errorJs + "}</script>");
	} else {
		customizeScriptArea.html(js);
	}
}

function makeBindKeyDownJs(functionName, keyCode, script) {
	var result = "";
	result += "function " + functionName + "() {";
	result += "$(document).keydown(function(e) {";
	result += "if(e.keyCode == " + keyCode + ") {";
	result += script;
	result += "}";
	result += "});";
	result += "}";
	return result;
}

function validate(value, area) {
	var result = "";
	if(area.length > 0) {
		result += drawText("<div class='errorMessage'>" + area + "に書いたプログラムにバグがおるぞ！プログラム内容を確認するんじゃ。</div>") + returnCode;
	} else {
		result += drawText("<div class='errorMessage'>プログラムにバグがおるぞ！プログラム内容を確認するんじゃ。</div>") + returnCode;
	}
	
	//1行ずつ処理
	var hasError = false;
	var lines = makeLines(value);

	var errorHtml;
	errorHtml = "<div class='error'>";
	for(var i = 0; i < lines.length; i++) {
		var line = lines[i];
		var error = validateLine(line);

		errorHtml += "<div>" + line.replace(/"/g, '\\"');
		if(error.length > 0) {
			hasError = true;
			errorHtml += "&nbsp;<font color=\\\"red\\\">←「" + error + "」</font>";
		}
		errorHtml += "</div>";
	}
	result += drawHtml(errorHtml);

	if(hasError) {
		return result;
	} else {
		return "";
	}
}

function validateLine(line) {
	if(line.length == 0) {
		return "";
	}
	while(endsWith(line," ")) {
		line = line.substring(0, line.length - 1);
	}
	var message = "";
	var blockEnd = ["{", "}"];
	for(var i = 0; i < blockEnd.length; i++) {
		if(endsWith(line, blockEnd[i])) {
			return "";
		}
	}

	if(line.indexOf(";") != line.length - 1) {
		message = "[ ; ] が最後に入っていません。";
		return message;
	}
	return "";
}

function makeAllLines(value) {
	var result = "";
	var lines = makeLines(value);
	for(var i = 0; i < lines.length; i++) {
		var line = lines[i];
		result += convert(line);
	}
	return result;
}

function makeLines(value) {
	return value.split("\n");
}

function convert(line) {
	if(line.indexOf("println") != -1) {
		line = line.replace("println(", "");
		line = line.replace(");", "");
		line = drawLine(line);
	}
	if(line.indexOf("int") != -1) {
		line = line.replace("int", "var");
	}
	if(line.indexOf("char") != -1) {
		line = line.replace("char", "var");
	}
	if(line.indexOf("boolean") != -1) {
		line = line.replace("boolean", "var");
	}
	if(line.indexOf("while") != -1) {
		line = toInterval(line);
	}
	if(line.indexOf("break") != -1) {
		line = "clearInterval(intervalId" + loopId + ");return;";
	}
	if(line.indexOf("continue") != -1) {
		line = "return;";
	}
	return line;
}

function img(id, x, y, css) {
	if(!css) {
		css = "";
	}
  var img = $("<img src='images\\" + id + ".png' class='" + css + "'/>");
	img.addClass("charactor");
	img.css('left', (x * 60) + "px");
	img.css('top', (y * 60 + 40) + "px");
	return $("#resultBody").append(img);
}

function clearImage() {
	$("#resultBody").children("img:not('.noClear')").remove();
}

function drawLine(str) {
	if(str.length == 0 || str == "NaN") {
		str = "\"\"";
	}
	return "drawLineFunc(" + str + ");"
}

function drawLineFunc(str) {
	$("#resultBody").append("<div>" + str + "</div>");
}

function toInterval(str) {
	loopId++;
	var condition = str.replace("while", "").replace(")", "").replace("(", "").replace("{", "");
	var result = "";
	result += "var intervalId" + loopId + " = setInterval(loop" + loopId + ", 200);";
	result += "intervalArray.push(intervalId" + loopId + ");";
	result += "var count" + loopId + " = 0;";
	result += "function loop" + loopId + "() {";
//	result += "if( count" + loopId + " >= 100 ) { $(\"#resultBody\").append(\"<div class='errorMessage'>大変じゃ！ループが終わらん実装になっとるぞ！！プログラムを見直すんじゃ！</div>\");clearInterval(intervalId" + loopId + ");return;}count" + loopId + "++;";
	result += "count" + loopId + "++;";
	result += "if(!(" + condition + ")) { clearInterval(intervalId" + loopId + "); return; }";
	result += "clearImage();";
	return result;
}

function drawText(str) {
	return drawHtml("<div>" + str + "</div>");
}

function drawHtml(str) {
	return "$(\"#resultBody\").append(\"" + str + "\");"
}

/***********************************************
 *
 * 汎用
 *
 ***********************************************/
function endsWith(target, str) {
	return target.lastIndexOf(str) == target.length - 1;
}

function loadVersion() {
	if(typeof version === "undefined") {
		return;
	}
	var versionNumber = parseFloat(version.version);
	if(applicationVersion < versionNumber) {
    $.confirm({
        'title' : '最新情報',
        'message' : '新しいアプリがあるぞ！ダウンロードするか？',
        'buttons' : {
            'する' : {
								'class' : 'btn-small commandButton confirm',
                'action' : function() {
									window.open("http://www.ric.co.jp/book/youkai.html");
                }
            },
            'しない' : {
								'class' : 'btn-small commandButton confirm',
                'action' : function(target) {
                }
            }
        }
    });
	}
}

